resImgui, imgui = pcall(require, "mimgui")
ffi = require "ffi"
encoding = require "encoding"
encoding.default = "CP1251"
u8 = encoding.UTF8

local jsonTable = {
    ["main"] = {
        ["items"] = 0,
        ["time"] = 12,
        ["weather"] = 0,
        ["timeL"] = 23,
        ["weatherL"] = 45,
        ["windowX"] = 189,
        ["windowY"] = 419,
    },
    ["buffer"] = {
        ["menu"] = "ctw",
        ["time"] = "ct",
        ["weather"] = "cw",
    },
    ["bool"] = {
        ["stats"] = false,
        ["time"] = false,
        ["weather"] = false,
        ["timeDN"] = false,
        ["limits"] = false,
        ["pcTime"] = false,
    },
    ["period"] = {
        ["time00"] = 0,
        ["time10"] = 23,
        ["weather00"] = 0,
    },
    ["stats"] = {
        ["time"] = true,
        ["weather"] = true,
        ["items"] = false,
        ["timeL"] = false,
        ["weatherL"] = false,
        ["menuCmd"] = false,
        ["timeCmd"] = false,
        ["weatherCmd"] = false,
        ["timeB"] = false,
        ["weatherB"] = false,
        ["pcTime"] = false,
    },
    ["style"] = {
        ["mainTransparence"] = 90,
        ["text"] = "{4169E1}",
        ["oneMS"] = 0.255,
        ["twoMS"] = 0.412,
        ["threeMS"] = 0.882,
        ["fourMS"] = 0.000,
    },
}

if not doesDirectoryExist(getWorkingDirectory() .. "/config") then 
    createDirectory(getWorkingDirectory() .. "/config")
end

if not doesFileExist(getWorkingDirectory() .. "/config/" .. thisScript().name:gsub(".lua", "") .. ".json") then
    local file = io.open(getWorkingDirectory() .. "/config/" .. thisScript().name:gsub(".lua", "") .. ".json", "w")
    file:write(encodeJson(jsonTable))
    file:close()
    local file = io.open(getWorkingDirectory() .. "/config/" .. thisScript().name:gsub(".lua", "") .. ".json", "r")
    if file then
        config = decodeJson(file:read('*a'))
    end
else
    local file = io.open(getWorkingDirectory() .. "/config/" .. thisScript().name:gsub(".lua", "") .. ".json", "r")
    if file then
        config = decodeJson(file:read('*a'))
    end
    file:close()
end

function main()
    while not isSampAvailable() do wait(100) end

    if not resImgui then
        sampAddChatMessage("{4169E1}[Changer Time & Weather] {FFFFFF}     {5A90CE}MIMGUI")
        sampAddChatMessage("{4169E1}[Changer Time & Weather] {FFFFFF}     ")
        setClipboardText("https://www.blast.hk/threads/66959/")
        thisScript():unload()
    end

    sampAddChatMessage(config["style"]["text"] .. "[Changer Time & Weather] {FFFFFF}  ! | : /" .. config["buffer"]["menu"] .. " | : Sadow")

    sampRegisterChatCommand(config["buffer"]["menu"], cmd_menu)
    sampRegisterChatCommand(config["buffer"]["time"], cmd_time)
    sampRegisterChatCommand(config["buffer"]["weather"], cmd_weather)

    while true do
        wait(0)

        tag = config["style"]["text"] .. "[Changer Time & Weather] {FFFFFF}"

        imguiBuffer1 = imgui.new.char[256](tostring(u8(config["buffer"]["menu"])))
        imguiBuffer2 = imgui.new.char[256](tostring(u8(config["buffer"]["time"])))
        imguiBuffer3 = imgui.new.char[256](tostring(u8(config["buffer"]["weather"])))
        imguiBuffer4 = imgui.new.int(config["main"]["timeL"])
        imguiBuffer5 = imgui.new.int(config["main"]["weatherL"])
        imguiSlider1 = imgui.new.int(readMemory(0xB70153, 1, true))
        imguiSlider2 = imgui.new.int(readMemory(0xC81320, 2, true))
        imguiSlider3 = imgui.new.int(config["main"]["time"])
        imguiSlider4 = imgui.new.int(config["main"]["weather"])
        imguiStyle1 = imgui.new.float[4](config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], config["style"]["fourMS"])
        imguiBool1 = imgui.new.bool(config["bool"]["time"])
        imguiBool2 = imgui.new.bool(config["bool"]["weather"])
        imguiBool3 = imgui.new.bool(config["bool"]["limits"])
        imguiBool4 = imgui.new.bool(config["bool"]["pcTime"])
        imguiBool5 = imgui.new.bool(config["bool"]["timeDN"])
        imguiBool6 = imgui.new.bool(config["stats"]["time"])
        imguiBool7 = imgui.new.bool(config["stats"]["weather"])
        imguiBool8 = imgui.new.bool(config["stats"]["items"])
        imguiBool9 = imgui.new.bool(config["stats"]["timeL"])
        imguiBool10 = imgui.new.bool(config["stats"]["weatherL"])
        imguiBool11 = imgui.new.bool(config["stats"]["menuCmd"])
        imguiBool12 = imgui.new.bool(config["stats"]["timeCmd"])
        imguiBool13 = imgui.new.bool(config["stats"]["weatherCmd"])
        imguiBool14 = imgui.new.bool(config["stats"]["timeB"])
        imguiBool15 = imgui.new.bool(config["stats"]["weatherB"])
        imguiBool16 = imgui.new.bool(config["stats"]["pcTime"])

        if config["bool"]["time"] == true and readMemory(0xB70153, 1, true) ~= config["main"]["time"] then
            local bs = raknetNewBitStream()
            raknetBitStreamWriteInt8(bs, config["main"]["time"])
            raknetEmulRpcReceiveBitStream(29, bs)
            raknetDeleteBitStream(bs)
        end

        if config["bool"]["weather"] == true and readMemory(0xC81320, 2, true) ~= config["main"]["weather"] then
            forceWeatherNow(config["main"]["weather"])
        end

        if config["bool"]["pcTime"] == true and readMemory(0xB70153, 1, true) ~= tonumber(os.date("%H")) then
            local bs = raknetNewBitStream()
            raknetBitStreamWriteInt8(bs, os.date("%H"))
            raknetEmulRpcReceiveBitStream(29, bs)
            raknetDeleteBitStream(bs)
        end

        if config["bool"]["timeDN"] == true then
            local pBool = false
            for a = 0, config["main"]["items"] do
                if config["period"]["time0" .. a] <= config["period"]["time1" .. a] then
                    for i = config["period"]["time0" .. a], config["period"]["time1" .. a] do
                        if getTimeOfDay() == i and readMemory(0xC81320, 2, true) ~= config["period"]["weather0" .. a] then
                            forceWeatherNow(config["period"]["weather0" .. a])
                        end
                    end
                elseif config["period"]["time0" .. a] > config["period"]["time1" .. a] then
                    for i = 0, config["period"]["time1" .. a] do
                        if getTimeOfDay() == i and readMemory(0xC81320, 2, true) ~= config["period"]["weather0" .. a] then
                            forceWeatherNow(config["period"]["weather0" .. a])
                        end
                        if i == config["period"]["time1" .. a] then
                            pBool = true
                        end
                    end
                end
                if pBool then
                    for i = config["period"]["time0" .. a], config["main"]["timeL"] do
                        if getTimeOfDay() == i and readMemory(0xC81320, 2, true) ~= config["period"]["weather0" .. a] then
                            forceWeatherNow(config["period"]["weather0" .. a])
                        end
                        if i == config["main"]["timeL"] then
                            pBool = false
                        end
                    end
                end
            end
        end

    end
end

local imguiWindow = imgui.new.bool(false)
local imguiWindowStats = imgui.new.bool(config["bool"]["stats"])
local imguiWindowSettings = imgui.new.bool(false)
local imguiSlider5 = imgui.new.int(config["style"]["mainTransparence"])
local posmX, posmY = getScreenResolution() / 2, select(2, getScreenResolution()) / 2
local possX, possY = 610, select(2, getScreenResolution()) / 2
local postX, postY = config["main"]["windowX"], config["main"]["windowY"]

function cmd_menu()
    imguiWindow[0] = not imguiWindow[0]
end

function cmd_time(arg)
    if arg:find("(%d+)") and (tonumber(arg) >= 0 and tonumber(arg) <= config["main"]["timeL"]) and config["bool"]["time"] == false and config["bool"]["pcTime"] == false then
        local bs = raknetNewBitStream()
        raknetBitStreamWriteInt8(bs, tonumber(arg))
        raknetEmulRpcReceiveBitStream(29, bs)
        raknetDeleteBitStream(bs)
        sampAddChatMessage(tag .. " " .. tonumber(arg) .. " (-)")
    elseif config["bool"]["time"] == true and config["bool"]["pcTime"] == true then
        sampAddChatMessage(tag .. "   " .. '"  "' .. '  "    "!')
    elseif config["bool"]["time"] == true then
        sampAddChatMessage(tag .. "   " .. '"  "!')
    elseif config["bool"]["pcTime"] == true then
        sampAddChatMessage(tag .. "   " .. '"    "!')
    else
        sampAddChatMessage(tag .. "   0   " .. config["main"]["timeL"] .. " (-)")
    end
end

function cmd_weather(arg)
    if arg:find("(%d+)") and (tonumber(arg) >= 0 and tonumber(arg) <= config["main"]["weatherL"]) and config["bool"]["weather"] == false then
        forceWeatherNow(tonumber(arg))
        sampAddChatMessage(tag .. "   " .. tonumber(arg))
    elseif config["bool"]["weather"] then
        sampAddChatMessage(tag .. "   " .. '"  "!')
    else
        sampAddChatMessage(tag .. "    0  " .. config["main"]["weatherL"])
    end
end

imgui.OnInitialize(function()
    imgui.Style()
    imgui.GetIO().IniFilename = nil
end)

local newFrame = imgui.OnFrame(
    function() return imguiWindow[0] end,
    function(self)
    if config["bool"]["settings"] == true then
        imguiWindowSettings[0] = true
    end
    imgui.SetNextWindowPos(imgui.ImVec2(posmX, posmY), imgui.Cond.Always, imgui.ImVec2(0.5, 0.5))
    imgui.Begin("Changer Time & Weather", imguiWindow, imgui.WindowFlags.AlwaysAutoResize + imgui.WindowFlags.NoResize + imgui.WindowFlags.NoCollapse)
    imgui.Text(u8" :")
    imgui.PushStyleVarVec2(imgui.StyleVar.FramePadding, imgui.ImVec2(10, 4))
    imgui.PushItemWidth(95)
    if imgui.InputText(u8"  ", imguiBuffer1, 256, imgui.InputTextFlags.EnterReturnsTrue) then
        if ffi.string(imguiBuffer1) ~= "" and not ffi.string(imguiBuffer1):match("(%s)") then
            sampUnregisterChatCommand(config["buffer"]["menu"])
            config["buffer"]["menu"] = u8:decode(ffi.string(imguiBuffer1))
            saveJson()
            sampRegisterChatCommand(config["buffer"]["menu"], cmd_menu)
        else
            sampUnregisterChatCommand(config["buffer"]["menu"])
            config["buffer"]["menu"] = "ctw"
            saveJson()
            sampRegisterChatCommand(config["buffer"]["menu"], cmd_menu)
        end
    end
    imgui.SameLine(30)
    imgui.Ques("     ")
    imgui.SameLine(15)
    imgui.Text("/")
    if imgui.InputText(u8" ", imguiBuffer2, 256, imgui.InputTextFlags.EnterReturnsTrue) then
        if ffi.string(imguiBuffer2) ~= "" and not ffi.string(imguiBuffer2):match("(%s)") then
            sampUnregisterChatCommand(config["buffer"]["time"])
            config["buffer"]["time"] = u8:decode(ffi.string(imguiBuffer2))
            saveJson()
            sampRegisterChatCommand(config["buffer"]["time"], cmd_time)
        else
            sampUnregisterChatCommand(config["buffer"]["time"])
            config["buffer"]["time"] = "ct"
            saveJson()
            sampRegisterChatCommand(config["buffer"]["time"], cmd_time)
        end
    end
    imgui.SameLine(30)
    imgui.Ques("    ")
    imgui.SameLine(15)
    imgui.Text("/")
    if imgui.InputText(u8" ", imguiBuffer3, 256, imgui.InputTextFlags.EnterReturnsTrue) then
        if ffi.string(imguiBuffer3) ~= "" and not ffi.string(imguiBuffer3):match("(%s)") then
            sampUnregisterChatCommand(config["buffer"]["weather"])
            config["buffer"]["weather"] = u8:decode(ffi.string(imguiBuffer3))
            saveJson()
            sampRegisterChatCommand(config["buffer"]["weather"], cmd_weather)
        else
            sampUnregisterChatCommand(config["buffer"]["weather"])
            config["buffer"]["weather"] = "cw"
            saveJson()
            sampRegisterChatCommand(config["buffer"]["weather"], cmd_weather)
        end
    end
    imgui.SameLine(30)
    imgui.Ques("    ")
    imgui.SameLine(15)
    imgui.Text("/")
    imgui.PopItemWidth()
    imgui.PopStyleVar()
    imgui.Separator()
    if imgui.SliderInt(u8"##1", imguiSlider1, 0, config["main"]["timeL"]) then
        if config["bool"]["time"] == false and config["bool"]["pcTime"] == false then
            local bs = raknetNewBitStream()
            raknetBitStreamWriteInt8(bs, imguiSlider1[0])
            raknetEmulRpcReceiveBitStream(29, bs)
            raknetDeleteBitStream(bs)
        elseif config["bool"]["time"] == true and config["bool"]["pcTime"] == true then
            sampAddChatMessage(tag .. "   " .. '"  "' .. '  "    "!')
        elseif config["bool"]["time"] == true then
            sampAddChatMessage(tag .. "   " .. '"  "!')
        elseif config["bool"]["pcTime"] == true then
            sampAddChatMessage(tag .. "   " .. '"    "!')
        end
    end
    imgui.SameLine(30)
    imgui.Ques("  ")
    if imgui.SliderInt(u8"##2", imguiSlider2, 0, config["main"]["weatherL"]) then
        if config["bool"]["weather"] == false then
            forceWeatherNow(imguiSlider2[0])
        else
            sampAddChatMessage(tag .. "   " .. '"  "!')
        end
    end
    imgui.SameLine(30)
    imgui.Ques("  ")
    imgui.Separator()
    if imgui.Checkbox(u8"  ", imguiBool1) then
        if config["bool"]["timeDN"] == false and config["bool"]["pcTime"] == false then
            config["bool"]["time"] = imguiBool1[0]
            saveJson()
        elseif config["bool"]["timeDN"] == true and config["bool"]["pcTime"] then
            sampAddChatMessage(tag .. "   " .. '" "' .. '  "    "!')
        elseif config["bool"]["timeDN"] == true then
            sampAddChatMessage(tag .. "   " .. '" "!')
        elseif config["bool"]["pcTime"] == true then
            sampAddChatMessage(tag .. "   " .. '"    "!')
        end
    end
    imgui.SameLine(30)
    imgui.Ques("   ")
    imgui.SameLine(170)
    if imgui.Checkbox(u8"  ", imguiBool2) then
        if config["bool"]["timeDN"] == false then
            config["bool"]["weather"] = imguiBool2[0]
            saveJson()
        else
            sampAddChatMessage(tag .. "   !")
        end
    end
    imgui.SameLine(30)
    imgui.Ques("   ")
    if config["bool"]["time"] == true then
        if imgui.SliderInt(u8"##3", imguiSlider3, 0, config["main"]["timeL"]) then
            config["main"]["time"] = imguiSlider3[0]
            saveJson()
        end
        imgui.SameLine(30)
        imgui.Ques("   ")
        if config["bool"]["weather"] == false then
            imgui.Separator()
        end
    end
    if config["bool"]["weather"] == true then
            if imgui.SliderInt(u8"##4", imguiSlider4, 0, config["main"]["weatherL"]) then
                config["main"]["weather"] = imguiSlider4[0]
                saveJson()
            end
            imgui.SameLine(30)
            imgui.Ques("   ")
            imgui.Separator()
    end
    if imgui.Checkbox(u8"", imguiBool3) then
        config["bool"]["limits"] = imguiBool3[0]
        saveJson()
    end
    imgui.SameLine(30)
    imgui.Ques("    /")
    imgui.SameLine(105)
    if imgui.Checkbox(u8"    ", imguiBool4) then
        if config["bool"]["time"] == false then
            config["bool"]["pcTime"] = imguiBool4[0]
            saveJson()
        else
            sampAddChatMessage(tag .. "   " .. '"  "!')
        end
    end
    imgui.SameLine(30)
    imgui.Ques("      \n    (  )")
    if config["bool"]["limits"] == true then
        imgui.PushItemWidth(70)
        if imgui.InputInt(u8" ", imguiBuffer4, 0, 0, imgui.InputTextFlags.EnterReturnsTrue) then
            config["main"]["timeL"] = imguiBuffer4[0]
            saveJson()
        end
        imgui.SameLine(30)
        imgui.Ques("   ")
        if imgui.InputInt(u8" ", imguiBuffer5, 0, 0, imgui.InputTextFlags.EnterReturnsTrue) then
            config["main"]["weatherL"] = imguiBuffer5[0]
            saveJson()
        end
        imgui.SameLine(30)
        imgui.Ques("   ")
        imgui.PopItemWidth()
        imgui.Separator()
    end
    if imgui.Checkbox(u8" ", imguiBool5) then
        if config["bool"]["time"] == false and config["bool"]["weather"] == false then
            config["bool"]["timeDN"] = imguiBool5[0]
            saveJson()
        elseif config["bool"]["time"] == true and config["bool"]["weather"] == true then
            sampAddChatMessage(tag .. "   " .. '"  "' .. '  "  "!')
        elseif config["bool"]["time"] == true then
            sampAddChatMessage(tag .. "   " .. '"  "!')
        elseif config["bool"]["weather"] == true then
            sampAddChatMessage(tag .. "   " .. '"  "!')
        end
    end
    if config["bool"]["timeDN"] == true then
        imgui.SameLine(140)
        if imgui.Button(u8"+") then
            config["main"]["items"] = config["main"]["items"] + 1
            saveJson()
            for i = 0, config["main"]["items"] do
                if config["period"]["time0" .. i] == nil or config["period"]["time1" .. i] == nil or config["period"]["weather0" .. i] == nil then
                    config["period"]["time0" .. i] = 0
                    config["period"]["time1" .. i] = 23
                    config["period"]["weather0" .. i] = 0
                    saveJson()
                end
            end
        end
        imgui.SameLine(160)
        if imgui.Button(u8"-") then
            if config["main"]["items"] ~= 0 then
                config["period"]["time0" .. config["main"]["items"]] = nil
                config["period"]["time1" .. config["main"]["items"]] = nil
                config["period"]["weather0" .. config["main"]["items"]] = nil
                config["main"]["items"] = config["main"]["items"] - 1
                saveJson()
            end
        end
        imgui.SameLine(180)
        imgui.Ques("     \n    \n  \n  +  -  /\n   ")
        imgui.SameLine(205)
    else
        imgui.SameLine(30)
        imgui.Ques("     \n    \n  ")
        imgui.SameLine(165)
    end
    if imgui.Checkbox(u8"", imguiWindowSettings) then
        config["bool"]["settings"] = imguiWindowSettings[0]
        saveJson()
    end
    imgui.SameLine(30)
    imgui.Ques("      \n         ")
    if config["bool"]["timeDN"] == true then
        imgui.Separator()
        for i = 0, config["main"]["items"] do
            imguiSlider6 = imgui.new.int(config["period"]["time0" .. i])
            imguiSlider7 = imgui.new.int(config["period"]["time1" .. i])
            imguiSlider8 = imgui.new.int(config["period"]["weather0" .. i])
            if imgui.CollapsingHeader(u8"  #" .. i + 1) then
                if imgui.SliderInt(u8" ##1" .. i, imguiSlider6, 0, config["main"]["timeL"]) then
                    config["period"]["time0" .. i] = imguiSlider6[0]
                    saveJson()
                end
                imgui.SameLine(30)
                imgui.Ques(" " .. config["period"]["time0" .. i] .. " (-)  (   )")
                if imgui.SliderInt(u8" ##1" .. i, imguiSlider7, 0, config["main"]["timeL"]) then
                    config["period"]["time1" .. i] = imguiSlider7[0]
                    saveJson()
                end
                imgui.SameLine(30)
                imgui.Ques(" " .. config["period"]["time0" .. i] .. " (-)  " .. config["period"]["time1" .. i] .. " (-)  (   )")
                if imgui.SliderInt(u8"##1" .. i, imguiSlider8, 0, config["main"]["weatherL"]) then
                    config["period"]["weather0" .. i] = imguiSlider8[0]
                    saveJson()
                end
                imgui.SameLine(30)
                imgui.Ques(" " .. config["period"]["time0" .. i] .. " (-)  " .. config["period"]["time1" .. i] .. " (-)     " .. config["period"]["weather0" .. i])
            end
        end
    end
    imgui.End()
end)

local newFrame = imgui.OnFrame(
    function() return imguiWindowSettings[0] end,
    function(self)
    if imguiWindow[0] == true and config["bool"]["settings"] == true then
        imgui.SetNextWindowPos(imgui.ImVec2(possX, possY), imgui.Cond.Always, imgui.ImVec2(0.5, 0.5))
        imgui.Begin("Changer Time & Weather || Settings", nil, imgui.WindowFlags.AlwaysAutoResize + imgui.WindowFlags.NoResize + imgui.WindowFlags.NoCollapse)
        if imgui.CollapsingHeader(u8" Mimgui ") then
            if imgui.ColorEdit4(u8"##Style", imguiStyle1, imgui.ColorEditFlags.NoInputs) then
                config["style"]["text"] = "{" .. string.sub(bit.tohex(join_argb(imguiStyle1[3] * 255, imguiStyle1[0] * 255, imguiStyle1[1] * 255, imguiStyle1[2] * 255)), 3, 8) .. "}"
                config["style"]["oneMS"] = imguiStyle1[0]
                config["style"]["twoMS"] = imguiStyle1[1]
                config["style"]["threeMS"] = imguiStyle1[2]
                config["style"]["fourMS"] = imguiStyle1[3]
                saveJson()
                imgui.Style()
            end
            imgui.SameLine(40)
            imgui.Text(u8" ")
            imgui.PushItemWidth(120)
            if imgui.SliderInt(u8" ", imguiSlider5, 0, 100, "%d%%") then
                config["style"]["mainTransparence"] = imguiSlider5[0]
                saveJson()
                imgui.Style()
            end
            imgui.PopItemWidth()
            if imgui.Button(u8"  ") then
                lua_thread.create(function()
                    showCursor(true, true)
                    checkCursor = true
                    sampSetCursorMode(4)
                    sampAddChatMessage(tag .. " {5A90CE} {FFFFFF}  !")
                    while checkCursor do
                        local cX, cY = getCursorPos()
                        posmX, posmY = cX, cY
                        if isKeyDown(32) then
                            sampSetCursorMode(0)
                            checkCursor = false
                            showCursor(false, false)
                            sampAddChatMessage(tag .. "  !")
                        end
                        wait(0)
                    end
                end)
            end
            imgui.SameLine(30)
            imgui.Ques("        \n          ,     ")
            if imgui.Button(u8"   ") then
                lua_thread.create(function()
                    showCursor(true, true)
                    checkCursor = true
                    sampSetCursorMode(4)
                    sampAddChatMessage(tag .. " {5A90CE} {FFFFFF}  !")
                    while checkCursor do
                        local cX, cY = getCursorPos()
                        possX, possY = cX, cY
                        if isKeyDown(32) then
                            sampSetCursorMode(0)
                            checkCursor = false
                            showCursor(false, false)
                            sampAddChatMessage(tag .. "  !")
                        end
                        wait(0)
                    end
                end)
            end
            imgui.SameLine(30)
            imgui.Ques("        \n          ,     ")
            if imgui.Button(u8"   ") then
                lua_thread.create(function()
                    showCursor(true, true)
                    checkCursor = true
                    sampSetCursorMode(4)
                    sampAddChatMessage(tag .. " {5A90CE} {FFFFFF}  !")
                    while checkCursor do
                        local cX, cY = getCursorPos()
                        postX, postY = cX, cY
                        if isKeyDown(32) then
                            sampSetCursorMode(0)
                            config["main"]["windowX"], config["main"]["windowY"] = postX, postY
                            checkCursor = false
                            showCursor(false, false)
                            saveJson()
                            sampAddChatMessage(tag .. "  !")
                        end
                        wait(0)
                    end
                end)
            end
            imgui.SameLine(30)
            imgui.Ques("        \n          ,     ")
        end
        if imgui.CollapsingHeader(u8"##5") then
            if imgui.Checkbox(u8"##6", imguiWindowStats) then
                config["bool"]["stats"] = imguiWindowStats[0]
                saveJson()
            end
            imgui.SameLine(30)
            imgui.Ques("         ")
            if config["bool"]["stats"] == true then
                imgui.Separator()
                imgui.Text(u8"  :")
                if imgui.Checkbox(u8"", imguiBool6) then
                    config["stats"]["time"] = imguiBool6[0]
                    saveJson()
                end
                if imgui.Checkbox(u8"", imguiBool7) then
                    config["stats"]["weather"] = imguiBool7[0]
                    saveJson()
                end
                if imgui.Checkbox(u8"- ", imguiBool8) then
                    config["stats"]["items"] = imguiBool8[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool9) then
                    config["stats"]["timeL"] = imguiBool9[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool10) then
                    config["stats"]["weatherL"] = imguiBool10[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool11) then
                    config["stats"]["menuCmd"] = imguiBool11[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool12) then
                    config["stats"]["timeCmd"] = imguiBool12[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool13) then
                    config["stats"]["weatherCmd"] = imguiBool13[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool14) then
                    config["stats"]["timeB"] = imguiBool14[0]
                    saveJson()
                end
                if imgui.Checkbox(u8" ", imguiBool15) then
                    config["stats"]["weatherB"] = imguiBool15[0]
                    saveJson()
                end
                if imgui.Checkbox(u8"    ", imguiBool16) then
                    config["stats"]["pcTime"] = imguiBool16[0]
                    saveJson()
                end
            end
            imgui.End()
        end
    else
        imguiWindowSettings[0] = false
    end
end)

local newFrame = imgui.OnFrame(
    function() return imguiWindowStats[0] end,
    function (self)
    self.HideCursor = true
    imgui.SetNextWindowPos(imgui.ImVec2(postX, postY), imgui.Cond.Always, imgui.ImVec2(0.5, 0.5))
    imgui.Begin("Changer Time & Weather || Stats", nil, imgui.WindowFlags.AlwaysAutoResize + imgui.WindowFlags.NoMove + imgui.WindowFlags.NoResize + imgui.WindowFlags.NoCollapse)
    if config["stats"]["time"] == true then
        imgui.Text(u8"  : " .. readMemory(0xB70153, 1, true) .. u8" (-)")
    end
    if config["stats"]["weather"] == true then
        imgui.Text(u8"  : " .. readMemory(0xC81320, 2, true))
    end
    if config["stats"]["items"] == true then
        if config["bool"]["timeDN"] == true then
            imgui.Text(u8"  : " .. config["main"]["items"] + 1)
        end
    end
    if config["stats"]["timeL"] == true then
        imgui.Text(u8"  : " .. config["main"]["timeL"])
    end
    if config["stats"]["weatherL"] == true then
        imgui.Text(u8"  : " .. config["main"]["weatherL"])
    end
    if config ["stats"]["menuCmd"] == true then
        imgui.Text(u8"   : /" .. config["buffer"]["menu"])
    end
    if config["stats"]["timeCmd"] == true then
        imgui.Text(u8"   : /" .. config["buffer"]["time"])
    end
    if config["stats"]["weatherCmd"] == true then
        imgui.Text(u8"   : /" .. config["buffer"]["weather"])
    end
    if config["stats"]["items"] == true then
        if config["bool"]["timeDN"] == true then
            imgui.Text(u8"   " .. u8'" ":')
            imgui.TextColored(imgui.ImVec4(0.0, 1.0, 0.0, 1.0), u8"", imgui.SameLine())
        else
            imgui.Text(u8"   " .. u8'" ":')
            imgui.TextColored(imgui.ImVec4(1.0, 0.0, 0.0, 1.0), u8"", imgui.SameLine())
        end
    end
    if config ["stats"]["timeB"] == true then
        if config["bool"]["time"] == true then
            imgui.Text(u8"   " .. u8'"  ":')
            imgui.TextColored(imgui.ImVec4(0.0, 1.0, 0.0, 1.0), u8"", imgui.SameLine())
        else
            imgui.Text(u8"   " .. u8'"  ":')
            imgui.TextColored(imgui.ImVec4(1.0, 0.0, 0.0, 1.0), u8"", imgui.SameLine())
        end
    end
    if config["stats"]["weatherB"] == true then
        if config["bool"]["weather"] == true then
            imgui.Text(u8"   " .. u8'"  ":')
            imgui.TextColored(imgui.ImVec4(0.0, 1.0, 0.0, 1.0), u8"", imgui.SameLine())
        else
            imgui.Text(u8"   " .. u8'"  ":')
            imgui.TextColored(imgui.ImVec4(1.0, 0.0, 0.0, 1.0), u8"", imgui.SameLine())
        end
    end
    if config["stats"]["pcTime"] == true then
        if config["bool"]["pcTime"] == true then
            imgui.Text(u8"   " .. u8'"    ":')
            imgui.TextColored(imgui.ImVec4(0.0, 1.0, 0.0, 1.0), u8"", imgui.SameLine())
        else
            imgui.Text(u8"   " .. u8'"    ":')
            imgui.TextColored(imgui.ImVec4(1.0, 0.0, 0.0, 1.0), u8"", imgui.SameLine())
        end
    end
    imgui.End()
end)

function imgui.Ques(text)
    imgui.SameLine()
    imgui.TextDisabled("(?)")
    if imgui.IsItemHovered() then
        imgui.BeginTooltip()
        imgui.TextUnformatted(u8(text))
        imgui.EndTooltip()
    end
end

function imgui.Style()
    imgui.SwitchContext()

    imgui.GetStyle().WindowPadding = imgui.ImVec2(10, 10)
	imgui.GetStyle().WindowRounding = 8
	imgui.GetStyle().ChildRounding = 8
	imgui.GetStyle().FramePadding = imgui.ImVec2(5, 4)
	imgui.GetStyle().FrameRounding = 16
	imgui.GetStyle().TouchExtraPadding = imgui.ImVec2(0, 0)
	imgui.GetStyle().IndentSpacing = 21
	imgui.GetStyle().ScrollbarSize = 10
	imgui.GetStyle().ScrollbarRounding = 0
	imgui.GetStyle().GrabMinSize = 20
	imgui.GetStyle().GrabRounding = 16
    imgui.GetStyle().WindowTitleAlign = imgui.ImVec2(0.5, 0.5)
	imgui.GetStyle().ButtonTextAlign = imgui.ImVec2(1, 1)

    imgui.GetStyle().Colors[imgui.Col.WindowBg]               = imgui.ImVec4(0.00, 0.00, 0.00, config["style"]["mainTransparence"] / 100)
    imgui.GetStyle().Colors[imgui.Col.ChildBg]                = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], config["style"]["fourMS"])
    imgui.GetStyle().Colors[imgui.Col.PopupBg]                = imgui.ImVec4(0.00, 0.00, 0.00, config["style"]["mainTransparence"] / 100)
    imgui.GetStyle().Colors[imgui.Col.Border]                 = imgui.ImVec4(0.00, 0.00, 0.00, 0.00)
    imgui.GetStyle().Colors[imgui.Col.BorderShadow]           = imgui.ImVec4(0.00, 0.00, 0.00, 0.00)
    imgui.GetStyle().Colors[imgui.Col.FrameBg]                = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.FrameBgHovered]         = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.FrameBgActive]          = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.TitleBg]                = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.TitleBgActive]          = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.TitleBgCollapsed]       = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.MenuBarBg]              = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarBg]            = imgui.ImVec4(0.12, 0.12, 0.12, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarGrab]          = imgui.ImVec4(0.00, 0.00, 0.00, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarGrabHovered]   = imgui.ImVec4(0.41, 0.41, 0.41, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ScrollbarGrabActive]    = imgui.ImVec4(0.51, 0.51, 0.51, 1.00)
    imgui.GetStyle().Colors[imgui.Col.CheckMark]              = imgui.ImVec4(1.00, 1.00, 1.00, 1.00)
    imgui.GetStyle().Colors[imgui.Col.SliderGrab]             = imgui.ImVec4(config["style"]["oneMS"] + 0.20, config["style"]["twoMS"] + 0.20, config["style"]["threeMS"] + 0.20, 1.00)
    imgui.GetStyle().Colors[imgui.Col.SliderGrabActive]       = imgui.ImVec4(config["style"]["oneMS"] + 0.30, config["style"]["twoMS"] + 0.30, config["style"]["threeMS"] + 0.30, 1.00)
    imgui.GetStyle().Colors[imgui.Col.Button]                 = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.ButtonHovered]          = imgui.ImVec4(config["style"]["oneMS"] + 0.10, config["style"]["twoMS"] + 0.10, config["style"]["threeMS"] + 0.10, 1.00)
    imgui.GetStyle().Colors[imgui.Col.ButtonActive]           = imgui.ImVec4(config["style"]["oneMS"] + 0.30, config["style"]["twoMS"] + 0.30, config["style"]["threeMS"] + 0.30, 1.00)
    imgui.GetStyle().Colors[imgui.Col.Header]                 = imgui.ImVec4(config["style"]["oneMS"], config["style"]["twoMS"], config["style"]["threeMS"], 1.00)
    imgui.GetStyle().Colors[imgui.Col.HeaderHovered]          = imgui.ImVec4(config["style"]["oneMS"] + 0.10, config["style"]["twoMS"] + 0.10, config["style"]["threeMS"] + 0.10, 1.00)
    imgui.GetStyle().Colors[imgui.Col.HeaderActive]           = imgui.ImVec4(config["style"]["oneMS"] + 0.30, config["style"]["twoMS"] + 0.30, config["style"]["threeMS"] + 0.30, 1.00)
    imgui.GetStyle().Colors[imgui.Col.Separator]              = imgui.ImVec4(0.27, 0.27, 0.27, 0.9)
    imgui.GetStyle().Colors[imgui.Col.SeparatorHovered]       = imgui.ImVec4(0.27, 0.27, 0.27, 0.9)
    imgui.GetStyle().Colors[imgui.Col.SeparatorActive]        = imgui.ImVec4(0.27, 0.27, 0.27, 0.9)
    imgui.GetStyle().Colors[imgui.Col.ResizeGrip]             = imgui.ImVec4(1.00, 1.00, 1.00, 0.25)
    imgui.GetStyle().Colors[imgui.Col.ResizeGripHovered]      = imgui.ImVec4(1.00, 1.00, 1.00, 0.67)
    imgui.GetStyle().Colors[imgui.Col.ResizeGripActive]       = imgui.ImVec4(1.00, 1.00, 1.00, 0.95)
    imgui.GetStyle().Colors[imgui.Col.TextSelectedBg]         = imgui.ImVec4(config["style"]["oneMS"] + 0.30, config["style"]["twoMS"] + 0.30, config["style"]["threeMS"] + 0.30, 0.7)
end

function join_argb(a, r, g, b)
    local argb = b
    argb = bit.bor(argb, bit.lshift(g, 8))
    argb = bit.bor(argb, bit.lshift(r, 16))
    argb = bit.bor(argb, bit.lshift(a, 24))
    return argb
end

function saveJson()
    local file = io.open(getWorkingDirectory() .. "/config/" .. thisScript().name:gsub(".lua", "") .. ".json", "w")
    file:write(encodeJson(config))
    file:close()
end